key = script.Parent
local open = 0

function rotateMod(mod, center, rotation)
	local parts = {}
	local function scan(parent)
		for _, obj in pairs(parent:GetChildren()) do
			if (obj:IsA("BasePart")) then
				table.insert(parts, obj)
			end
			scan(obj)
		end
	end

	scan(mod)
	for _, part in pairs(parts) do
		part.CFrame = (center * rotation * (center:inverse() * part.CFrame))
	end
end

function onClicked()

	if open == 0 then
		open = 1
		local mod = key
		local step = 1
		for i = 0, 7, step do
			rotateMod(mod, mod:GetModelCFrame(), CFrame.Angles(0, 0, 0.2))
			wait()
		end

	else

		open = 0
		local mod = key
		local step = 1
		for i = 0, 7, step do
			rotateMod(mod, mod:GetModelCFrame(), CFrame.Angles(0, 0, -0.2))
			wait()
		end
	end
end

script.Parent.Use.MouseClick:connect(onClicked)